<script lang="ts">
	import turnkeyInstanceTypes from "../provider/TurnkeyInstanceTypes";
	import { clientApps } from "../provider/ClientApps";
	import { fade, fly } from "svelte/transition";
	import { bridgesPrice } from "../provider/MatrixBridges";
	import { matrixBots } from "../provider/MatrixBots";
	import { additionalServices, additionalMatrixServices } from "../provider/MatrixServices";
	import { supportOptions } from "../provider/SupportOptions";
	import type { OrderFormInterface } from "../entity/OrderForm";

	export let entity: OrderFormInterface = null;

	let matrixBasePrice = 5;
	let totalSum: number = 0;
	let priceItems: {name: string, price: number}[] = [];

	$: {
		totalSum = 0;
		priceItems = [];

		totalSum += matrixBasePrice;
		priceItems = [
			{
				name: "Matrix base",
				price: matrixBasePrice,
			},
		];

		if (entity.hostingType === "turnkey" && entity.turnkeyInstanceTypeId) {
			let turnkeyInstance = turnkeyInstanceTypes.find(
				(instance) => instance.id === entity.turnkeyInstanceTypeId
			);
			if (turnkeyInstance) {
				priceItems.push({
					name: `VPS by us, size: ${turnkeyInstance.name}`,
					price: turnkeyInstance.price,
				});
				totalSum += turnkeyInstance.price;
			}
		}

		if (entity.selectedApps.length > 0) {
			for (let selectedApp of entity.selectedApps) {
				let clientApp = clientApps.find(
					(app) => app.id === selectedApp
				);
				if (clientApp && clientApp.price > 0) {
					priceItems.push({
						name: `Client app: ${clientApp.name}`,
						price: clientApp.price,
					});
					totalSum += clientApp.price;
				}
			}
		}

		if (!entity.serverIsUnderpowered && entity.selectedBridges.length > 0) {
			priceItems.push({
				name: `Matrix bridges`,
				price: bridgesPrice,
			});
			totalSum += bridgesPrice;
		}

		if (!entity.serverIsUnderpowered && entity.selectedBots.length > 0) {
			for (let selectedBot of entity.selectedBots) {
				let matrixBot = matrixBots.find(
					(bot) => bot.id === selectedBot.id
				);
				if (matrixBot) {
					priceItems.push({
						name: `Bot: ${matrixBot.name}`,
						price: matrixBot.price,
					});
					totalSum += matrixBot.price;
				}
			}
		}

		if (entity.selectedMatrixServices.length > 0) {
			for (let selectedService of entity.selectedMatrixServices) {
				let service = additionalMatrixServices.find(
					(service) => service.id === selectedService.id
				);
				if (service && service.price > 0) {
					priceItems.push({
						name: `Matrix Service: ${service.name}`,
						price: service.price,
					});
					totalSum += service.price;
				}
			}
		}

		if (entity.selectedServices.length > 0) {
			for (let selectedService of entity.selectedServices) {
				let service = additionalServices.find(
					(service) => service.id === selectedService.id
				);
				if (service && service.price > 0) {
					priceItems.push({
						name: `Service: ${service.name}`,
						price: service.price,
					});
					totalSum += service.price;
				}
			}
		}

		if (entity.supportType) {
			let supportType = supportOptions.find((supportOption) => supportOption.id == entity.supportType);
			if (supportType && supportType.price > 0) {
				priceItems.push({
					name: `Support: ${supportType.name}`,
					price: supportType.price,
				});
				totalSum += supportType.price;
			}
		}
	}
</script>

{#if totalSum !== 0}
<div class="mb-3 rounded">
	<div class="card price-basket px-3 py-3" in:fly={{ y: 200, duration: 1000 }} out:fade>
		<h4 class="card-title sum-title fw-bold pb-2 mb-3">Basket:</h4>
		{#each priceItems as priceItem}
			<div class="price-item d-flex justify-content-between">
				{priceItem.name} <strong class="ps-2">${priceItem.price}</strong>
			</div>
		{/each}
		<div class="mt-4 d-flex justify-content-between">
			<span>Total (monthly):</span>
			<div>
				{#key totalSum}
				<span class="fw-bold">$</span><span class="d-inline-block" in:fly={{ y: -20 }}>
					<strong>{totalSum}</strong>
				</span>
				{/key}
			</div>
		</div>
	</div>
</div>
{/if}

<style>
	.sum-title {
		border-bottom: 2px solid #eee;
	}
	.price-item {
		border-bottom: 2px dotted #eee;
	}
	.price-basket {
		position: initial;
		background: var(--body-bg-color-default);
		z-index: 5;
		min-width: 350px;
		max-height: 50vh;
		border: 1px solid #f49300;
		font-size: 1.1rem;
		top: 25%;
		right: 5%;
		overflow-y: auto;
	}
	@media(min-width: 768px) {
		.price-basket {
			position: fixed;
		}
	}
</style>
